;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Parasite
;by wiiqwertyuiop
;Give Credit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RIGHTSPED = $0B	;Marios speed right

LEFTSPED  = $F5 ;Marios speed left 

Jump_Height = $00 ;Marios jump height

Sprite_Jump = $D5 ;sprite 1st jump height

Jump_Height_Sprite = $C0 ;Sprites 2nd jump height

Jump_Height_Sprite2 = $B5 ;Sprites 3rd jump height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Start code below
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


                    dcb "$INIT"
                    RTL
                 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; START
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"                                    
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR SPRITE_CODE_START   ;  |
                    PLB                     ;  |
                    RTL                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		NoContact:
		RTS

		SPRITE_CODE_START   
		JSR Graphics


		
		LDA $1588,x
		AND #$04 ; If the sprite is in air ..
		BEQ NotOnGround ; Don't set speeds and branch.
		JSL $019138 	;
		JSL $018022 	; 
		LDA #Sprite_Jump	;
		STA $AA,x	;
		LDA $0F33	;Jump
		CMP #$05	;
		BEQ JMPHIGH 	;
		LDA $0F33	;
		CMP #$09	;
		BEQ JMPHIGHR	;
		NotOnGround	;
		JSL $01802A 	; Apply speed.


		JSL $01A7DC	  ; Check for Mario/sprite contact ..
		BCC NoContact	  ; Return if there isn't.

		STZ $AA,x 	;No more jumping


		LDA $13		;\
		AND #$03	;|
		BEQ GetGoin	;|
		INC $C2,x	;|This is just graphics stuff
		LDA $C2,x	;|
		CMP #$02	;|
		BNE GetGoin	;|
		STZ $C2,x	;/

GetGoin:

		LDA $94 	 ;get on mario	
		STA $E4,x 		
		LDA $95 		
		STA $14E0,x 
		LDA $96 
		CLC 
		ADC #$10 
		STA $D8,x 
		LDA $97 
		ADC #$00
		STA $14D4,x ;ends here


		LDA $7D			;\check if he's trying to jump
		CMP #$C1		; |
		BCS JUMP		;/	if so branch
		LDA $15			;\
		CMP #$01		; |
		BEQ WALKR		; |See what direction mario is going
		LDA $15			; |
		CMP #$02		; |
		BEQ WALKL		;/
		



		LDA $7B		;\Don't let mario run
		CMP #$23	;|
		BEQ WALKR	;|
		LDA $7B		;|
		CMP #$24	;|
		BEQ WALKR	;|
		LDA $7B		;|
		CMP #$DD	;|
		BEQ WALKL	;|
		LDA $7B		;|
		CMP #$DC	;|
		BEQ WALKL	;|
		STZ $13E4	;|
		STZ $14A0	;/
		LDA $16		; \ if buttons are being pressed, increase the button counter
		CMP #$80	;  |
		BNE No		;  |
		INC $1534,x	; /
		LDA $1534,x	;
		CMP #$01	; change CMP #$xx to other values to change how many button presses are
		BCC No		;   required to shake off 
		JSR OFF		;
		RTS

		JMPHIGH: 
		LDA #Jump_Height_Sprite
		STA $AA,x
		RTS
		JMPHIGHR: 
		LDA #Jump_Height_Sprite2
		STA $AA,x
		NO:
		RTS

		JUMP:
		LDA #Jump_Height
		STA $7D
		RTS

		WALKR:
		LDA #RIGHTSPED
		STA $7B
		RTS

		WALKL:
		LDA #LEFTSPED
		STA $7B
		NO_PRESS_BUTTON:		
		RTS		;Final Retrun


;===================================
;Graphics Code
;===================================
TILETOGET:
	dcb $62,$64,$64,$64

Graphics:
	
		 	 	
		  		


	JSR GET_DRAW_INFO
	LDY #$40
	
	LDA $157C,x
	STA $02
	LDA $00
	STA $0200,y
	LDA $01
	STA $0201,y
	PHY
	LDY $C2,x
	LDA TILETOGET,y
	PLY
	STA $0202,y
	LDA $15F6,x
	ORA $64
	STA $0203,y


	PHY
	TYA ;
	LSR ;
	LSR ; Set to 16x16 tile
	TAY ;
	LDA #$02 ;
	ORA $15A0,x ; horizontal offscreen flag
	STA $0420,y ;
	PLY
	INY
	INY
	INY
	INY

	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
	XBA	 ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC	 ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC	 ;  |
	ADC.W #$0040            ;  |
	CMP.W #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
	
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY	 ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
	CLC	 ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP	 ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP	 ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |
ON_SCREEN_Y         DEY	 ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC	 ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC	 ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS	 ; return

INVALID             PLA	 ; \ return from *main gfx routine* subroutine...
	PLA	 ;  |    ...(not just this subroutine)
	RTS	 ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB HORZ POS
;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642
;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;


OFF:
		LDA #$9F
		STA $AA,x              
		LDA #$0A
		STA $B6,x  
RTS



